# -*- coding: utf-8 -*-
# 瀏覽器希望無音愛有空白，但是處理標音時希望較好認
import unicodedata

LIAN_JI_HU = '-'
KHIN_SIANN_HU = '--'
# 句中是為著加速標音
句中標點符號 = {
    '、', '﹑', '､', '-', '—', '~', '～',
    '·', '‧',  # 外國人名中間
    "'", '＇', '"', '‘', '’', '“', '”', '〝', '〞', '′', '‵',
    '「', '」', '｢', '｣', '『', '』',
    '【', '】', '〈', '〉', '《', '》', '（', '）', '＜', '＞',
    '(', ')', '<', '>', '[', ']', '{', '}',
    '+', '*', '/', '=', '^', '＋', '－', '＊', '／', '＝', '$', '#', '#',
    ':', '：', '﹕', '–', '—', '―', '─', '──', '｜', '︱',
    '•',
}

# 斷句是考慮著翻譯，閣有語音合成愛做的正規化
斷句標點符號 = (
    {'\n', } |
    {'，', '。', '．', '！', '？', '…', '……', '...', } |
    {',', '.', '!', '?', } |
    {'﹐', '﹒', '﹗', '﹖', } |
    {';', '；', '﹔', }
)

# Siann-tiāu
HAGFA_TIAU = {
    '', 'ˊ', 'ˋ', 'ˇ', '+', '^'
}
NGOO_SIU_LE = {
    '0': '˙', '1': '', '2': 'ˋ', '3': '˪',
    '4': '', '5': 'ˊ', '6': '˫', '7': '˫',
    '8': '㆐', '9': '^', '10': '㆐'
}

聲調符號 = (
    HAGFA_TIAU |
    set(NGOO_SIU_LE.values())
) - {''}


標點符號 = 句中標點符號 | 斷句標點符號

組字式符號 = '⿰⿱⿲⿳⿴⿵⿶⿷⿸⿹⿺⿻⿿'

# Ll　小寫， Lu　大寫， Md　數字， Mn　有調號英文，Lo　其他, So 組字式符號…
_統一碼羅馬字類 = {'Ll', 'Lu', 'Mn'}


def si_lomaji(jiguan):
    return 敢是拼音字元(jiguan) or jiguan.isdigit()


def 敢是拼音字元(字元):
    try:
        種類 = unicodedata.category(字元)
    except TypeError:
        return False
    return 種類 in _統一碼羅馬字類 or 字元 in ['ⁿ', "'", '_', ]


def 敢是注音符號(字元):
    return unicodedata.name(字元, '').startswith('BOPOMOFO LETTER')
